#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    long long fac[19];
    fac[0] = 1;
    for(int i=1;i<19;i++)
        fac[i] = fac[i-1] * i;

    int t;
    cin>>t;
    for(int i=0;i<t;i++)
    {
        long long n, m, k;
        cin>>n>>m>>k;
        if(n/k>18 || (n/k==18 && n%k!=0))
        {
            cout<<"Nie"<<endl;
            continue;
        }
        bool no = true;
        long long res=0;
        for(int j=0;j<k-n%k;j++)
        {
            res+=fac[n/k];
            if(res>m)
            {
                no = false;
                break;
            }
        }
        for(int j=0;j<n%k;j++)
        {
            if(!no)
                break;
            res+=fac[n/k+1];
            if(res>m)
                no=false;
        }
        if(no && res<m)
            cout<<"Tak"<<endl;
        else
            cout<<"Nie"<<endl;
    }

    return 0;
}